/*!
 * @file      INTalk.h
 * @brief     
 * @author    Jaehoon.Kim(jaehoon.kim@nhn.com)
 * @date      2011-12-09 
 * @warning   
 */

#ifndef _INTALK_H__
#define _INTALK_H__

#include <vector>

class INTalkClient;


enum NTalkCreateSesionErrorCode
{
	createSessionError_None,		//
	createSessionError_Connect,		//ä  
	createSessionError_InitRoom,	//ȭ 
};

enum NTalkCreateChatType
{
	typeChatCreate,		// ȭ  
	typeChatJoin,		// ʴ뿡 
};

enum NTalkRecvMsgType
{
	typeInvitemsg,  // ȭ ʴ ˸
	typeChatMsg,	// ȭ  ˸
	typeTypingMsg,	//   Է ˸
	typeExitMsg,	// ȭ  ˸

};

enum NTalkChatJoinErrorCode
{
	chatJoinError_None,						//
	chatJoinError_NoExist = 100,			// ʴ´ȭ
	chatJoinError_NoInviteUser = 110,		//ʴ  
	chatJoinError_AlreadyInviteUser = 120,	//̹ ʴ (  õ ߻  ִ ڵ̸,  Ѵ.)
};

enum NTalkInviteListErrorCode
{
	InviteListError_None,
	InviteListError_Error,
};

enum NTalkForceLeaveErrorCode
{
	forceLeaveError_None,			//   
	forceLeaveError_Fail			//   
};

enum NTalkTyping
{
	typeNonTyping,		//  Է ƴ
	typeTyping,			//  Է
};

// ʴϷ ϴ  Ʈ
//#pragma pack(push, 1)
typedef struct _tagINVITE_USER
{
	TCHAR* pszID;
	TCHAR* pszName;
	TCHAR* pszNickName;

	_tagINVITE_USER()
	{
		pszID = NULL;
		pszName = NULL;
		pszNickName = NULL;
	}
}INVITE_USER, *PINVITE_USER;
//#pragma pack(pop)

typedef struct _tagCOMM_USERINFO
{	
	USHORT nUserIdLen;
	TCHAR* pszUserID;
	USHORT nUserNameLength;
	TCHAR* pszUserName;
}COMM_USERINFO;

typedef struct _tagSEND_MSGRESULT
{
	USHORT nUserIdLen;
	TCHAR* pszUserID;
	USHORT nUserNameLength;
	TCHAR* pszUserName;
	USHORT nUserOsType;
	UINT nResult;
}SEND_MSGRESULT;

class INTalkClientEvents
{
public:
	/* ȭ */
	virtual void CALLBACK NtalkClient_OnCreateChatSession(INTalkClient* pNTClient, NTalkCreateChatType chatType, 
																			NTalkCreateSesionErrorCode eErrorCode) {};

	virtual void CALLBACK NtalkClient_OnInitRoom(INTalkClient* pNTClient, int roomid, NTalkCreateSesionErrorCode eErrorCode) {};
	/* ȭ ʴ ˸*/
	virtual void CALLBACK NtalkClient_OnInviteMsg(INTalkClient* pNTClient, int roomid, LPCTSTR srvaddress, int srvport, 
																			LPCTSTR userid, LPCTSTR nickname, int time) {}; 
	/* ȭ  ˸*/
	virtual void CALLBACK NtalkClient_OnReceiveChatMsg(INTalkClient* pNTClient,
														int roomid, 
														LPCTSTR userid,
														LPCTSTR nickname,
														int os_type, 
														int time,
														LPCTSTR pszMsg, 
														UINT msg_seq,
														CHARFORMAT2* pFont, 
														UINT nTid,
														BYTE msgType) {};

	/*   Է ˸ */
	virtual void CALLBACK NtalkClient_OnReceiveTypingMsg(INTalkClient* pNTClient, int roomid, 
															LPCTSTR userid, LPCTSTR nickname, int nOSType, NTalkTyping state) {}; 	
	// äû
	virtual void CALLBACK NtalkClient_OnChatJoin(INTalkClient* pNTClient, NTalkChatJoinErrorCode eErrorCode, int roomid, 
																	std::vector<PINVITE_USER>& vecUserList, int roomtype, UINT nJoinNum, UINT nLastMsgNum) {};

	/* ȭ   û  */
	virtual void CALLBACK NtalkClient_OnForceChatReJoin(INTalkClient* pNTClient, NTalkChatJoinErrorCode eErrorCode, 
																int roomid, std::vector<PINVITE_USER>& vecUserList) {}; 

	/* ȭ   û  */
	virtual void CALLBACK NtalkClient_OnForceChatLeave(INTalkClient* pNTClient, NTalkForceLeaveErrorCode eErrorCode, 
																int roomid, LPCTSTR userid) {}; 

	/* ȭ   ˸ */
	virtual void CALLBACK NtalkClient_OnPushForceLeave(INTalkClient* pNTClient, int roomid, LPCTSTR userid) {}; 

	/* ȭ   ˸ */
	virtual void CALLBACK NtalkClient_OnPushSessionClose(INTalkClient* pNTClient, int roomid) {}; 

	//ȭ˸
	virtual void CALLBACK NtalkClient_OnNewJoiner(INTalkClient* pNTClient, int roomid, LPCTSTR userid, LPCTSTR nickname, 
																				int time, UINT membercount, int jointype, int ostype) {}; 
	virtual void CALLBACK NtalkClient_OnForceReJoiner(INTalkClient* pNTClient, int roomid, LPCTSTR userid, LPCTSTR nickname, 
																								int time, UINT membercount) {}; 
	/*ȭ泪˸*/
	virtual void CALLBACK NtalkClient_OnChatLeaveJoiner(INTalkClient* pNTClient, int roomid, 
															LPCTSTR userid, LPCTSTR nickname, 
															int os_type, int time, UINT membercount) {}; 

	/*ȭ ۿ   */
	virtual void CALLBACK NtalkClient_OnAckSendMsg(INTalkClient* pNtClient, int roomid, UINT msg_seq, LPCTSTR userid, UINT tid, int time) {}; 
	/*ȭ*/
	virtual void CALLBACK NtalkClient_OnInviteList(INTalkClient* pNtClient, int roomid, NTalkInviteListErrorCode eErrorCode, 
													UINT nTotalMemberCount, UINT nTryCount, UINT nFailCount, std::vector<TCHAR*>& vecUserList) {}; 
	/*ȭ  ˸*/
	virtual void CALLBACK NtalkClient_OnRoomEnd(INTalkClient* pNtClient, int roomid, int type) {}; 

    /*ȭ   ˸*/
    virtual void CALLBACK NtalkClient_OnSessionEnd(INTalkClient* pNTClient, int roomid, 
        LPCTSTR userid, LPCTSTR nickname, int nOSType) {}; 

	/*ä  غ   ˸*/
	virtual void CALLBACK NtalkClient_OnServerNotReady(INTalkClient* pNtClient) {}; 
	/*ȭ   ˸*/
	virtual void CALLBACK NtalkClient_OnSendMsgFail(INTalkClient* pNtClient, int roomid, UINT msg_seq, UINT tid, int time, 
													int os_type, std::vector<COMM_USERINFO *>& vecFailUser) {};
	/*ȭ  */
	virtual void CALLBACK NtalkClient_OnMsgResult(INTalkClient* pNtClient, int room_id, UINT msg_seq, UINT tid, int time, 
													int os_type, int result_seq, std::vector<SEND_MSGRESULT *>& vecUserMsgResult) {};

	/*ä    ˸*/
	virtual void CALLBACK NtalkClient_OnServerSessionEnd(INTalkClient* pNtClient) {};

	/* ۿ   */
	virtual void CALLBACK NtalkClient_OnAckSendFile(INTalkClient* pNtClient, int roomid, UINT msg_seq, LPCTSTR userid, UINT tid, int time) {}; 

	/*  ˸*/
	virtual void CALLBACK NtalkClient_OnReceiveFile(INTalkClient* pNTClient, int roomid, LPCTSTR userid, LPCTSTR nickname, int os_type,
		int time, LPCTSTR pszFileName, int nFileSize, LPCTSTR pszURL, UINT msg_seq, UINT tid, BYTE msgType) {};

	virtual void CALLBACK NtalkClient_OnRecvPong() {};
};

class INTalkClient
{
public:	
	/* äù */
	virtual BOOL CreateChatSession(LPCTSTR strSrvAddress,
								   int nPort, 	 
								   ULONG nRoomID,
								   LPCTSTR pszCreaterID, 
								   LPCTSTR pszUserName,
								   LPCTSTR pszNickName,
								   BOOL bCreation = FALSE) = 0;

	virtual BOOL RequestInitRoom() = 0;

	virtual BOOL RequestReCoverSession() = 0;

	/*äù */
	virtual void DestroyChatSession() = 0;	
	/*äʴ*/
	virtual BOOL RegisterChatUsers(std::vector<PINVITE_USER> vecUserList) = 0;
	/*޼*/
	virtual BOOL RequestSendChatMsg(LPCTSTR pszMsg, CHARFORMAT2* pFont, UINT nTid, UINT nMsgSeq, BYTE MsgType) = 0;
	/*Է»¾˸*/
	virtual BOOL RequestTyping(NTalkTyping state) = 0; 
	/*ä*/
	virtual BOOL RequestChatJoin() = 0;
	/* â*/
	virtual BOOL RequestForceChatReJoin() = 0;
	/*ȭ */
	virtual BOOL RequestChatLeave() = 0;
	/* */
	virtual BOOL RequestForceLeave( LPCTSTR pszUserID, LPCTSTR pszUserName, LPCTSTR pszNickName ) = 0;
	/*ȭſϷ ˸*/
	virtual BOOL RequestAckRecvMsg(UINT nMsgSeq, UINT nTid, INT& nReason) = 0;
	/*ȭ۰ ˸*/
	virtual BOOL RequestAckMsgResult(UINT nMsgSeq, UINT nTid, UINT nResultSeq) = 0;
	/*PING üũ */
	virtual BOOL RequestSendPing() = 0;
	/* ˸*/
	virtual BOOL RequestFileSend(std::vector<std::wstring> vecReceiverIds, LPCTSTR pszFileName, UINT nFileSize, LPCTSTR pszURL, UINT nTid, UINT nMsgSeq) = 0;
	/*ϼſϷ ˸*/
	virtual BOOL RequestAckRecvFile(UINT nMsgSeq, UINT nTid) = 0;

	/*ȭ */
	virtual void SetNickname(LPCTSTR pszNickName) = 0;

	virtual void SetNetworkError(int error) = 0;
	virtual int  GetNetworkError() = 0;

};



#endif